Option Strict Off
Option Explicit On
Module Startup
	'MADE BY Cosmin Antohe cos55ap@gmail.com
	
	Private Declare Function RegOpenKeyEx Lib "advapi32.dll"  Alias "RegOpenKeyExA"(ByVal hKey As Integer, ByVal lpSubKey As String, ByVal ulOptions As Integer, ByVal samDesired As Integer, ByRef phkResult As Integer) As Integer
	Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Integer) As Integer
	
	Public Const REG_SZ As Short = 1 ' Unicode nul terminated String
	Public Const HKEY_CLASSES_ROOT As Integer = &H80000000
	Public Const HKEY_CURRENT_USER As Integer = &H80000001
	Public Const HKEY_LOCAL_MACHINE As Integer = &H80000002
	Public Const HKEY_USERS As Integer = &H80000003
	Public Const KEY_ALL_ACCESS As Integer = &H2003F
	
	Declare Function RegQueryValueExString Lib "advapi32.dll"  Alias "RegQueryValueExA"(ByVal hKey As Integer, ByVal lpValueName As String, ByVal lpReserved As Integer, ByRef lpType As Integer, ByVal lpData As String, ByRef lpcbData As Integer) As Integer
	Declare Function RegQueryValueExLong Lib "advapi32.dll"  Alias "RegQueryValueExA"(ByVal hKey As Integer, ByVal lpValueName As String, ByVal lpReserved As Integer, ByRef lpType As Integer, ByRef lpData As Integer, ByRef lpcbData As Integer) As Integer
	Declare Function RegQueryValueExNULL Lib "advapi32.dll"  Alias "RegQueryValueExA"(ByVal hKey As Integer, ByVal lpValueName As String, ByVal lpReserved As Integer, ByRef lpType As Integer, ByVal lpData As Integer, ByRef lpcbData As Integer) As Integer
	
	
	
	
	Public Function AutoDetect() As Byte
		Dim wDev As Short
		Dim i As Byte
		For i = 0 To 254
			'UPGRADE_WARNING: Couldn't resolve default property of object QueryValue(). Click for more: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
			wDev = Val(Mid(QueryValue(HKEY_LOCAL_MACHINE, "HARDWARE\DEVICEMAP\SERIALCOMM", "\Device\VCP" & i), 4, 3))
			If wDev > 0 Then
				AutoDetect = wDev
			Else
				Exit Function
			End If
		Next i
	End Function
	
	
	
	Public Function QueryValue(ByRef lPredefinedKey As Integer, ByRef sKeyName As String, ByRef sValueName As String) As Object
		' Description:
		'   This Function will return the data field of a value
		'
		' Syntax:
		'   Variable = QueryValue(Location, KeyName, ValueName)
		'
		'   Location must equal HKEY_CLASSES_ROOT, HKEY_CURRENT_USER, HKEY_lOCAL_MACHINE
		'   , HKEY_USERS
		'
		'   KeyName is the key that the value is under (example: "Software\Microsoft\Windows\CurrentVersion\Explorer")
		'
		'   ValueName is the name of the value you want to access (example: "link")
		
		Dim lRetVal As Integer 'result of the API functions
		Dim hKey As Integer 'handle of opened key
		Dim vValue As Object 'setting of queried value
		
		
		lRetVal = RegOpenKeyEx(lPredefinedKey, sKeyName, 0, KEY_ALL_ACCESS, hKey)
		lRetVal = QueryValueEx(hKey, sValueName, vValue)
		'MsgBox vValue
		'UPGRADE_WARNING: Couldn't resolve default property of object vValue. Click for more: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
		'UPGRADE_WARNING: Couldn't resolve default property of object QueryValue. Click for more: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
		QueryValue = vValue
		RegCloseKey(hKey)
	End Function
	
	
	Function QueryValueEx(ByVal lhKey As Integer, ByVal szValueName As String, ByRef vValue As Object) As Integer
		Dim REG_DWORD As Object
		Dim ERROR_NONE As Object
		Dim cch As Integer
		Dim lrc As Integer
		Dim lType As Integer
		Dim lValue As Integer
		Dim sValue As String
		
		On Error GoTo QueryValueExError
		
		
		
		' Determine the size and type of data to be read
		
		lrc = RegQueryValueExNULL(lhKey, szValueName, 0, lType, 0, cch)
		'UPGRADE_WARNING: Couldn't resolve default property of object ERROR_NONE. Click for more: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
		If lrc <> ERROR_NONE Then Error(5)
		
		'UPGRADE_WARNING: Couldn't resolve default property of object REG_DWORD. Click for more: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
		Select Case lType
			' For strings
			Case REG_SZ
				sValue = New String(Chr(0), cch)
				lrc = RegQueryValueExString(lhKey, szValueName, 0, lType, sValue, cch)
				'UPGRADE_WARNING: Couldn't resolve default property of object ERROR_NONE. Click for more: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
				If lrc = ERROR_NONE Then
					'UPGRADE_WARNING: Couldn't resolve default property of object vValue. Click for more: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
					vValue = Left(sValue, cch)
				Else
					'UPGRADE_WARNING: Couldn't resolve default property of object vValue. Click for more: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
					vValue = Nothing
				End If
				
				' For DWORDS
			Case REG_DWORD
				lrc = RegQueryValueExLong(lhKey, szValueName, 0, lType, lValue, cch)
				'UPGRADE_WARNING: Couldn't resolve default property of object ERROR_NONE. Click for more: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
				'UPGRADE_WARNING: Couldn't resolve default property of object vValue. Click for more: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
				If lrc = ERROR_NONE Then vValue = lValue
			Case Else
				'all other data types not supported
				lrc = -1
		End Select
		
QueryValueExExit: 
		
		QueryValueEx = lrc
		Exit Function
		
QueryValueExError: 
		
		Resume QueryValueExExit
		
	End Function
End Module